> ### Apache HTTP Server Version 2.0

> # Apache Module mod_auth_digest

> Description: | <description>User authentication using MD5 Digest Authentication.</description>
> Status: | Experimental
> Module Identifier: | auth_digest_module

> ## Summary

> This module implements HTTP Digest Authentication. However, it has not been extensively tested and is therefore marked experimental.

> See also

> - `AuthName`
> - `AuthType`
> - `Require`
> - `Satisfy`

> ## Directives

> - AuthDigestAlgorithm
> - AuthDigestDomain
> - AuthDigestFile
> - AuthDigestGroupFile
> - AuthDigestNcCheck
> - AuthDigestNonceFormat
> - AuthDigestNonceLifetime
> - AuthDigestQop

> ## Using Digest Authentication

> Using MD5 Digest authentication is very simple. Simply set up authentication normally, using "AuthType Digest" and "AuthDigestFile" instead of the normal "AuthType Basic" and "AuthUserFile"; also, replace any "AuthGroupFile" with "AuthDigestGroupFile". Then add a "AuthDigestDomain" directive containing at least the root URI(s) for this protection space. Example:

> > `<Location /private/> AuthType Digest AuthName "private area" AuthDigestDomain /private/ http://mirror.my.dom/private2/ AuthDigestFile /web/auth/.digest_pw Require valid-user </Location>`

> > Note

> > MD5 authentication provides a more secure password system than Basic authentication, but only works with supporting browsers. As of this writing (October 2001), the only major browsers which support digest authentication are Opera 4.0, MS Internet Explorer 5.0 and Amaya. Therefore, we do not yet recommend using this feature on a large Internet site. However, for personal and intra-net use, where browser users can be controlled, it is ideal.

> ## AuthDigestAlgorithm Directive

> Description: | Selects the algorithm used to calculate the challenge and response hases in digest authentication
> Syntax: | <syntax>AuthDigestAlgorithm MD5|MD5-sess</syntax>
> Default: | `AuthDigestAlgorithm MD5`
> Context: | directory, .htaccess
> Override: | AuthConfig
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> The `AuthDigestAlgorithm` directive selects the algorithm used to calculate the challenge and response hashes.

> MD5-sess is not correctly implemented yet.

> </usage>

> ## AuthDigestDomain Directive

> Description: | URIs that are in the same protection space for digest authentication
> Syntax: | <syntax>AuthDigestDomain URI [URI] ...</syntax>
> Context: | directory, .htaccess
> Override: | AuthConfig
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> The `AuthDigestDomain` directive allows you to specify one or more URIs which are in the same protection space (i.e. use the same realm and username/password info). The specified URIs are prefixes, i.e. the client will assume that all URIs "below" these are also protected by the same username/password. The URIs may be either absolute URIs (i.e. inluding a scheme, host, port, etc) or relative URIs.

> This directive should always be specified and contain at least the (set of) root URI(s) for this space. Omitting to do so will cause the client to send the Authorization header for every request sent to this server. Apart from increasing the size of the request, it may also have a detrimental effect on performance if "AuthDigestNcCheck" is on.

> The URIs specified can also point to different servers, in which case clients (which understand this) will then share username/password info across multiple servers without prompting the user each time.

> </usage>

> ## AuthDigestFile Directive

> Description: | Location of the text file containing the list of users and encoded passwords for digest authentication
> Syntax: | <syntax>AuthDigestFile file-path</syntax>
> Context: | directory, .htaccess
> Override: | AuthConfig
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> The `AuthDigestFile` directive sets the name of a textual file containing the list of users and encoded passwords for digest authentication. File-path is the absolute path to the user file.

> The digest file uses a special format. Files in this format can be created using the htdigest utility found in the support/ subdirectory of the Apache distribution.

> </usage>

> ## AuthDigestGroupFile Directive

> Description: | Name of the text file containing the list of groups for digest authentication
> Syntax: | <syntax>AuthDigestGroupFile file-path</syntax>
> Context: | directory, .htaccess
> Override: | AuthConfig
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> The `AuthDigestGroupFile` directive sets the name of a textual file containing the list of groups and their members (user names). File-path is the absolute path to the group file.

> Each line of the group file contains a groupname followed by a colon, followed by the member usernames separated by spaces. Example:

> > `mygroup: bob joe anne`

> Note that searching large text files is very inefficient.

> Security: make sure that the AuthGroupFile is stored outside the document tree of the web-server; do not put it in the directory that it protects. Otherwise, clients will be able to download the AuthGroupFile.

> </usage>

> ## AuthDigestNcCheck Directive

> Description: | Enables or disables checking of the nonce-count sent by the server
> Syntax: | <syntax>AuthDigestNcCheck On|Off</syntax>
> Default: | `AuthDigestNcCheck Off`
> Context: | server config
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> Not implemented yet.

> </usage>

> ## AuthDigestNonceFormat Directive

> Description: | Determines how the nonce is generated
> Syntax: | <syntax>???</syntax>
> Default: | `???`
> Context: | directory, .htaccess
> Override: | AuthConfig
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> Not implemented yet.

> </usage>

> ## AuthDigestNonceLifetime Directive

> Description: | How long the server nonce is valid
> Syntax: | <syntax>AuthDigestNonceLifetime seconds</syntax>
> Default: | `AuthDigestNonceLifetime 300`
> Context: | directory, .htaccess
> Override: | AuthConfig
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> The `AuthDigestNonceLifetime` directive controls how long the server nonce is valid. When the client contacts the server using an expired nonce the server will send back a 401 with `stale=true`. If seconds is greater than 0 then it specifies the amount of time for which the nonce is valid; this should probably never be set to less than 10 seconds. If seconds is less than 0 then the nonce never expires.

> </usage>

> ## AuthDigestQop Directive

> Description: | Determines the quality-of-protection to use in digest authentication
> Syntax: | <syntax>AuthDigestQop none|auth|auth-int [auth|auth-int]</syntax>
> Default: | `AuthDigestQop auth`
> Context: | directory, .htaccess
> Override: | AuthConfig
> Status: | Experimental
> Module: | mod_auth_digest

> <usage>

> The `AuthDigestQop` directive determines the quality-of-protection to use. auth will only do authentication (username/password); auth-int is authentication plus integrity checking (an MD5 hash of the entity is also computed and checked); none will cause the module to use the old RFC-2069 digest algorithm (which does not include integrity checking). Both auth and auth-int may be specified, in which the case the browser will choose which of these to use. none should only be used if the browser for some reason does not like the challenge it receives otherwise.

> auth-int is not implemented yet.

> </usage>

> ### Apache HTTP Server Version 2.0